<?php

// ##########################################################################
// #                       Thumbnail Creator                                #
// ##########################################################################
// # By: Darin Gilchrist                                                    #
// # 01/04/2009                                                             #
// #                                                                        #
// # This software is FREEWARE but not to be sold, re-packaged, or modified #
// # for commercial use without permission from the creator.                #
// ##########################################################################
// # Requirements:                                                          #
// # - PHP 5 minimum. (Not tested on other versions)                        #
// # - GD Library 2.0                                                       #
// ##########################################################################

$img = $_GET['img'] OR DIE("No image specified.");
$bgcolor = "FFFFFF";

$src_im = imagecreatefromjpeg($img);
$size = getimagesize($img);

$im = imagecreatetruecolor( $size[0], ($size[1]*1.5));

$bgcolor = get_rgb($im, $bgcolor);
imagefilledrectangle($im, 0, 0, $size[0], $size[1], $bgcolor);

imagecopy( $im, $src_im, 0, 0, 0, 0, $size[0], $size[1] );

$src_im = flipImage($src_im, $bgcolor);

imagecopy( $im, $src_im, 0, $size[1], 0, 0, $size[0], $size[1] );

// Output
header("Content-type: image/jpeg");
imagejpeg($im, NULL, 70);
imagedestroy($im);

function flipImage($image, $bgcolor)
{
    $w = imagesx($image);
    $h = imagesy($image);

    $flipped = imagecreatetruecolor($w, $h);

	imagefilledrectangle($flipped, 0, 0, $w, $h, $bgcolor);

    for ($y=1; $y<$h; $y++)
    {
    	imagecopymerge( $flipped, $image, 0, $y-6, 0, $h - $y, $w, 3, $h/$y );
    }

    return $flipped;
}

function get_rgb($im, $color)
{
	$color = trim($color, "\#");
	$r = hexdec(substr($color, 0, 2));
	$g = hexdec(substr($color, 2, 2));
	$b = hexdec(substr($color, 4, 2));
	return imagecolorallocate($im, $r, $g, $b);
}


?>